    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * ChartEditorManager.java
    029     * -----------------------
    030     * (C) Copyright 2005-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   ;
    034     *
    035     * Changes
    036     * -------
    037     * 24-Nov-2005 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.editor;
    042
    043    import org.jfree.chart.JFreeChart;
    044
    045    /**
    046     * The central point for obtaining {@link ChartEditor} instances for editing
    047     * charts.  Right now, the API is minimal - the plan is to extend this class
    048     * to provide customisation options for chart editors (for example, make some
    049     * editor items read-only).
    050     */
    051    public class ChartEditorManager {
    052
    053        /** This factory creates new {@link ChartEditor} instances as required. */
    054        static ChartEditorFactory factory = new DefaultChartEditorFactory();
    055
    056        /**
    057         * Private constructor prevents instantiation.
    058         */
    059        private ChartEditorManager() {
    060            // nothing to do
    061        }
    062
    063        /**
    064         * Returns the current factory.
    065         *
    066         * @return The current factory (never <code>null</code>).
    067         */
    068        public static ChartEditorFactory getChartEditorFactory() {
    069            return factory;
    070        }
    071
    072        /**
    073         * Sets the chart editor factory.
    074         *
    075         * @param f  the new factory (<code>null</code> not permitted).
    076         */
    077        public static void setChartEditorFactory(ChartEditorFactory f) {
    078            if (f == null) {
    079                throw new IllegalArgumentException("Null 'f' argument.");
    080            }
    081            factory = f;
    082        }
    083
    084        /**
    085         * Returns a component that can be used to edit the given chart.
    086         *
    087         * @param chart  the chart.
    088         *
    089         * @return The chart editor.
    090         */
    091        public static ChartEditor getChartEditor(JFreeChart chart) {
    092            return factory.createEditor(chart);
    093        }
    094    }